--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **             "Ukady programowalne CoolRunner II w praktyce"          **
-- **                                                                      **
-- **            Module: PushButton (przydatny komponent)                  **
-- **            Target device: XILINX CPLD                                **
-- **            Tool versions: ISE WebPACK 9.2i                           **
-- **            Date: BIAYSTOK, stycze 2009                             **
-- **                                                                      **
-- **                     Napisa : Andrzej Pawluczuk                      **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity PushButton is port ( KClk : in std_logic ;
                            Reset : in std_logic ;
                            KeyIn : in std_logic ;
                            Status : out std_logic ) ;
end PushButton ;

architecture Behavioral of PushButton is

  signal ShRegister : std_logic_vector ( 3 downto 0 ) ;
  signal KeyFlag : std_logic ;
  signal SetFlag : std_logic ;
  signal ClrFlag : std_logic ;

begin
  Status <= KeyFlag ;

  ShiftInstance : process ( KClk , Reset )
  begin
    if Reset = '0' then
      ShRegister <= "1111" ;
    else
      if KClk'event and KClk = '0' then
        ShRegister <= ShRegister ( 2 downto 0 ) & KeyIn ;
      end if ;
    end if ;
  end process ;

  FlsgInstance : process ( ClrFlag , SetFlag )
  begin
    if ClrFlag = '1' then
      KeyFlag <= '0' ;
    else
      if SetFlag = '1' then
        KeyFlag <= '1' ;
      end if ;
    end if ;
  end process ;

  SetFlag <= '1' when ( ShRegister = "0000" ) else '0' ;
  ClrFlag <= '1' when ( ShRegister = "1111" ) else '0' ;
end Behavioral ;
