--
-- **************************************************************************
-- **************************************************************************
-- **                                                                      **
-- **             "Ukady programowalne CoolRunner II w praktyce"          **
-- **                                                                      **
-- **            Module: Bcd (przydatny komponent)                         **
-- **            Target device: XILINX CPLD                                **
-- **            Tool versions: ISE WebPACK 9.2i                           **
-- **            Date: BIAYSTOK, stycze 2009                             **
-- **                                                                      **
-- **                     Napisa : Andrzej Pawluczuk                      **
-- **                                                                      **
-- **************************************************************************
-- **************************************************************************
--
-----------------------------------------------------------------------------
library IEEE ;
use IEEE.STD_LOGIC_1164.ALL ;
use IEEE.STD_LOGIC_ARITH.ALL ;
use IEEE.STD_LOGIC_UNSIGNED.ALL ;

entity bcd is port ( Clk : in std_logic ;
                     Reset : in std_logic ;
                     Enable : in std_logic ;
                     QOut : out std_logic_vector ( 3 downto 0 ) ) ;
end bcd;

architecture Behavioral of BCD is

  signal Cnt : std_logic_vector ( 3 downto 0 ) ;

begin
  process ( Clk , Reset , Enable )
  begin
    if Reset = '0' then
      Cnt <= "0000" ;
    else
      if Clk'event and Clk = '1' then
        if Enable = '1' then
          if Cnt = "1001" then
            Cnt <= "0000" ;
          else
            Cnt <= Cnt + "0001" ;
          end if ;
        end if ;
      end if ;
    end if ;
  end process ;

  QOut <= Cnt ;
end Behavioral;
